/** \file
  \brief  Documented

***********************************************************************/


/// wraps VARIANT types
/** 
***********************************************************************/
class AFX_CLASS_CD_CVariant CD_CVariant : public tagVARIANT
{
  // Constructors
public:
/// \name Konstruktoren */
//@{
  CD_CVariant();

  CD_CVariant(const VARIANT& varSrc);
  CD_CVariant(LPCVARIANT pSrc);
  CD_CVariant(const CD_CVariant& varSrc);

  CD_CVariant(LPCTSTR lpszSrc);
  CD_CVariant(LPCTSTR lpszSrc, VARTYPE vtSrc); // used to set to ANSI string
  CD_CVariant(CString& strSrc);

  CD_CVariant(BYTE nSrc);
  CD_CVariant(short nSrc, VARTYPE vtSrc = VT_I2);
  CD_CVariant(WORD wSrc);
  CD_CVariant(long lSrc, VARTYPE vtSrc = VT_I4);
  CD_CVariant(const COleCurrency& curSrc);
  CD_CVariant(DWORD dwSrc);
  CD_CVariant(int iSrc);

  CD_CVariant(LONGLONG nSrc);
  CD_CVariant(ULONGLONG nSrc);

  CD_CVariant(float fltSrc);
  CD_CVariant(double dblSrc);
  CD_CVariant(const COleDateTime& timeSrc);

  CD_CVariant(const CByteArray& arrSrc);
  CD_CVariant(const CLongBinary& lbSrc);

#if !defined(_WIN32_WCE)
  CD_CVariant(LPCITEMIDLIST pidl);
#endif
//@}

  // Operations
public:
/** \name A small subgroup */
//@{
  void Clear();
  void ChangeType(VARTYPE vartype, LPVARIANT pSrc = NULL);
//@}
  void Attach(VARIANT& varSrc);
  VARIANT Detach();
  void GetByteArrayFromVariantArray(CByteArray& bytes);

  BOOL operator==(const VARIANT& varSrc) const;
  BOOL operator==(LPCVARIANT pSrc) const;
  BOOL operator!=(const VARIANT& varSrc) const;
  BOOL operator!=(LPCVARIANT pSrc) const;
  /** \name Zuweisungsoperatoren */
  //@{
  const CD_CVariant& operator=(const VARIANT& varSrc);
  const CD_CVariant& operator=(LPCVARIANT pSrc);
  const CD_CVariant& operator=(const CD_CVariant& varSrc);

  const CD_CVariant& operator=(const LPCTSTR lpszSrc);
  const CD_CVariant& operator=(const CString& strSrc);

  const CD_CVariant& operator=(BYTE nSrc);
  const CD_CVariant& operator=(short nSrc);
  const CD_CVariant& operator=(WORD wSrc);
  const CD_CVariant& operator=(long lSrc);
  const CD_CVariant& operator=(int iSrc) {return operator=(long(iSrc));}
  const CD_CVariant& operator=(const COleCurrency& curSrc);
  const CD_CVariant& operator=(DWORD dwSrc);

  const CD_CVariant& operator=(LONGLONG nSrc);
  const CD_CVariant& operator=(ULONGLONG nSrc);

  const CD_CVariant& operator=(float fltSrc);
  const CD_CVariant& operator=(double dblSrc);
  const CD_CVariant& operator=(const COleDateTime& dateSrc);

  const CD_CVariant& operator=(const CByteArray& arrSrc);
  const CD_CVariant& operator=(const CLongBinary& lbSrc);
  //@}
  void SetString(LPCTSTR lpszSrc, VARTYPE vtSrc); // used to set ANSI string

  operator LPVARIANT();
  operator LPCVARIANT() const;

  // Implementation
public:
  ~CD_CVariant();
};
